/*
   Q-STEER ̃R݂ȐԊOM\tg

   2007 (C) Mio Software Lab. / Nishiyama, Naoki
   for GCC 3.3 and avr-libc

   ̃t@C͎ςȂĂȂDɂĂ˃CZXłB
   ̂܂܋ARɎgƂł܂B
@ IPI  FTDI-AVR ̃TvQlɂĂ܂B
   (IPI  FTDI-AVR œƂz肵Ă܂j
@ LȂAĂƂɎg܂B

@ PORTB3 : LED ȂłBLED SzȂЂƂ͓dRĂˁB
@ PORTB2 : fobOpóB38KHz ϒ̊|ĂȂg`j^ł܂B

   ȊỎH\ł́AAVR ̋NbNAgprbg[gɂāA
   @serial.h ̒萔ύXKv܂B
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/pgmspace.h>

#include "serial.h"

/* AVR CLOCK is 11.0517MHz */

/* ̃NbN̏ꍇ 425us ŃI[o[t[悤ɁA73(^C}l) ύX */
#define PSTART (255 - 73) // NbNˑ

unsigned char LEDISON = 0;
unsigned char BAND = 0 ;
unsigned char COMMAND = 0 ;
unsigned char NEXTCOMMAND = 0 ;
unsigned char REPEAT = 0 ;

//
// JE^O̓R}h؂ 0.425ms 쐬p
// JE^P͔g 38khz 쐬p
//
void port_init(void)
{
  DDRD  = 0xFC ;
  PORTD = 0xFC ;

  DDRB  = 0x0C ; // DDRB3,DDRB2 = 1 (OUTPUT)
  PORTB = 0xF3 ; // ALL PULL UP except B3,B2

  TCCR0  = _BV(CS01) + _BV(CS00) ; // TIMER0 \[XNbN 64 

  TCNT1H = 0 ;             
  TCNT1L = 0 ;             
  OCR1H  = (0);          //  38KHz : NbNˑ
  OCR1L  = (144);        //  38KHz : NbNˑ
  TCCR1A = _BV(COM1A0) ;	// RyA}b`ŃgO
  TCCR1B = _BV(CTC1)   + _BV(CS10) ;   // CLK x 1 , RyA}b`ŃNA
  TIMSK  = _BV(TOIE0) ;  // ^C}I[ot[Ŋ荞
}

void LEDOFF(void) {
	if (LEDISON == 1) {
		LEDISON = 0 ;
		PORTB &= (~(0x04)) ;    
		TCCR1A = 0 ; // ^C}P~
		TCCR1B = 0 ;
		TCNT1H = 0 ;             
    	TCNT1L = 0 ;
	}
}

void LEDON(void) {       
	if (LEDISON == 0) {     
		LEDISON = 1 ;
		PORTB |= 0x04 ;
		TCCR1A = _BV(COM1A0) ;	// ^C}PX^[g
		TCCR1B = _BV(CTC1)   + _BV(CS10) ;   // CLK x 1 , RyA}b`ŃNA
	}
}

//
// 0.425 msƂ̊荞
//
SIGNAL(SIG_OVERFLOW0)
{
#define WAITSTATE (9)
	static unsigned char state = 0 ;
	static unsigned char cnt = 0 ;
	static unsigned char nextis1 = 0 ;
	static unsigned char nextisgap = 0 ;

	unsigned char mask ;

	// 1 o
	if (nextis1) {
		LEDON() ;
		if (--nextis1 == 0) {
			nextisgap = 1 ;
		}
		goto FIN ;
	}
	
	// ԃMbvo
	if (nextisgap) {
		LEDOFF() ;
		nextisgap = 0 ;
		goto FIN ;
	}

	switch(state) {
	case 0: 
		if (COMMAND != 0) {
			REPEAT-- ;
			if (REPEAT == 0) {
				COMMAND = 0 ;
				goto FIN ;
			}
			// wb_
			LEDON() ;
			nextis1 = 3 ;
			state = 1 ;
		} else {
			LEDOFF() ;
			if (NEXTCOMMAND > 0) {
				COMMAND = NEXTCOMMAND ;
				NEXTCOMMAND = 0 ;
				REPEAT = 2 ;
			}
		}
		break ;
	case 1:
		// BAND
		LEDON() ;
		if (cnt == 0) {
			if (BAND & 0x02) {
				nextis1 = 1 ;
			} else {
				nextisgap = 1;
			}
			cnt++ ;
		} else {
			if (BAND & 0x01) {
				nextis1 = 1 ;
			} else {
				nextisgap = 1;
			}
			state = 2 ;
			cnt = 0 ;
		}
		break ;
	case 2:
		// COMMAND
		LEDON() ;
		mask = (0x08 >> cnt) ;
		if (COMMAND & mask) {
			nextis1 = 1 ;
		} else {
			nextisgap = 1;
		}

		if(++cnt == 4) {
			cnt = 0 ;
			state = WAITSTATE ;
		}
		break ;
	default: // WAITSTATE
		LEDOFF() ;
		cnt++ ;
		if (cnt >= BAND * 24 + 20) {
			cnt = 0 ;
			state = 0 ;
		}
	}
FIN:;
	TCNT0 = PSTART ;
}

int main (void)
{
	int c ;

	port_init() ;
	uart0_init() ;
	sei() ;
	while(1) {
		c = uart_getc() ;
	    if (c >= 0) {
    		uart_putc(c) ;
			switch(c) {
			case 'A':
			case 'B':
			case 'C':
			case 'D':
				BAND = (c - 'A') ;
				break ;
			case 'a':
			case 'b':
			case 'c':
			case 'd':
				BAND = (c - 'a') ;
				break ;
			default:
				NEXTCOMMAND = c & 0x0F ;
				break ;
    		}
		}
    	uart_send() ;		
	} ;
}
